<?php

class MageOne_RateLimit_Model_ConfigProvider
{
    protected static $rateLimitConfig = null;

    public function __construct()
    {
        self::$rateLimitConfig = Mage::getConfig()->getNode('global/mageone_ratelimit')->asArray();
    }

    public function getRateLimitConfig($path = null)
    {
        if ($path !== null) {
            foreach (self::$rateLimitConfig as $config) {
                if ($config['route'] == $path) {
                    return [
                        'max_queries' => (int)$config['max_queries_in_time_window'],
                        'time_window' => (int)$config['time_window_in_seconds'],
                        'enabled' => isset($config['enabled']) ? (bool)$config['enabled'] : false
                    ];
                }
            }
            return null;
        }
        return self::$rateLimitConfig;
    }

    public function isRateLimitedRoute($route)
    {
        $config = $this->getRateLimitConfig($route);
        return $config && $config['enabled'];
    }
}
