<?php

class MageOne_RateLimit_Model_Observer
{
    protected $configProvider;

    public function __construct()
    {
        $this->configProvider = new MageOne_RateLimit_Model_ConfigProvider();
    }

    public function preDispatch(Varien_Event_Observer $observer)
    {
        if (!Mage::getStoreConfigFlag('web/rate_limit/enable_rate_limit')) {
            return;
        }

        $currentUrl = Mage::helper('core/url')->getCurrentUrl();
        $url = Mage::getSingleton('core/url')->parseUrl($currentUrl);
        $path = $url->getPath();

        if (!$this->configProvider->isRateLimitedRoute($path)) {
            return;
        }

        $ratelimiter = Mage::getModel('mageone_ratelimit/rateLimiter');
        $ratelimiter->validateRequest($path);
    }
}

